#include <iostream>
#include <stack>
#include <queue>

using namespace std;

int n,m,f;
int delta[1024][10];
int final[1024];
int prev [1024];
int digit[1024];

void show(int x)
{ stack<int> s; 
  while(x>0)
  { s.push(digit[x]);
    x = prev[x];
  }
  
  int cnt = 0;
  while(! s.empty())
  { int d = s.top();
    s.pop();
    cout << d;
    cnt++;
    if(cnt==50)
    { cout << endl;
      cnt = 0;
    }  
  }
  if(cnt>0) cout << endl;
}   

int main()
{ cin >> n >> m;
  for(int i=0; i<n; i++)
    for(int j=1; j<=m; j++)
      cin >> delta[i][j];
  cin >> f;
  for(int i=1; i<=f; i++)
  { int x;
    cin >> x;
    final[x] = 1;
  }  
    
  queue<int> q;
  
  prev[0] = digit[0] = -1;
  q.push(0);
  
  while(! q.empty())
  { int x = q.front();
    q.pop();
    
    for(int j=1; j<=m; j++)
    { int y = delta[x][j];
      if(digit[y]==0)
      { prev[y] = x;
        digit[y] = j;
        q.push(y);
        if(final[y]==1)
        { show(y);
          return 0;
        }
      } 
    } 
    
  }
  
  cout << 0 << endl;             
    
  return 0;
}
         
  
