#include <stdio.h>

#define MAXN 1024
#define MAXM 16

struct _PARENT{
	int p;
	char c;
};
typedef struct _PARENT PARENT;
int g[MAXN][MAXM];
int n,m;
PARENT p[MAXN];
char lock[MAXN];
int Solve(int start);

int main()
{
	int i,j,t;
	scanf("%d%d",&n,&m);
	for(i=0;i<n;i++)
		for(j=0;j<m;j++)
			scanf("%d",&g[i][j]);
	memset(p,~0,sizeof(PARENT)*n);
	memset(lock,0,sizeof(char)*n);
	scanf("%d",&j);
	for(i=0;i<j;i++){
		scanf("%d",&t);
		lock[t]=1;
	}
	i=Solve(0);
	if(i==-1){
		printf("0");
		goto exit;
	}
	n=0;
	while(i!=0){
		g[0][n++]=p[i].c+'0';
		i=p[i].p;
	}
	printf("%c",g[0][--n]+1);
	for(j=n-1;j>-1;j--){
		if((n-j)%50==0)
			printf("\n");
		printf("%c",g[0][j]+1);
	}
exit:
	printf("\n");
	return 0;
}

int Solve(int start)
{
	int q[MAXN];
	int qs=0,qe=1,i,t;
	q[0]=start;
	//p[start].p=start;
	while(qs<qe){
		for(i=0;i<m;i++){
			if(p[(t= g[q[qs]] [i]) ].p==-1){
				p[t].p=q[qs];
				p[t].c=i;
				if(lock[t])
					return t;
				q[qe++]=g[q[qs]][i];
			}
		}
		qs++;
	}
	return -1;
}

