#include <iostream>
#include <deque>
#include <queue>
using namespace std;

int at[1000][9];
int lc[1000]= {0};
int used[1000] = {1};
int prev[1000] = {-1};
int m,n;

int bfs()
{
	deque <int> q;
	q.push_front(0);
	
	while(!q.empty())
	{
		int c = q.front();
		q.pop_front();
		for(int i = 0; i < m; i++)
		if(!used[at[c][i]])
		{
			if(!lc[at[c][i]])
			{
				used[at[c][i]] = 1;
				prev[at[c][i]] = c;
				q.push_back(at[c][i]);	
			}
			else 
			{
				prev[at[c][i]] = c;
				return at[c][i];
			}
	   }	
	}	
	return -1;
}


int main()
{
	cin >> n >> m;
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++ )
			cin >> at[i][j];
	}
	int t;
	cin >> t;
	for(int i = 0 ; i < t; i++)
	{
		int s;
		cin >> s;
		lc[s] = 1;	
	}
	prev[0] = -1;
	int ex = bfs();
	
	queue <int> s;
	
	while(prev[ex] != -1)
	{
		for(int i = 0; i < m; i++)
		if(at[prev[ex]][i] == ex)
		{
			s.push(i);
			ex = prev[ex];
			break;
		}	
	}
	while(!s.empty())
	{
		cout << s.back() + 1;
		s.pop();
	}
	system("pause");
	return 0;	
}
