#include <cstdio>
#include <queue>
using namespace std;

int trans[1024][16];
int n, m;
bool term[1024];

int prev[1024], lett[1024];
queue<int> q;

int bfs() {
	memset(prev, -1, sizeof(prev));
	q.push(0);
	int c, a, t;
	while(!q.empty()) {
		c = q.front(); q.pop();
		if(term[c]) return c;
		
		for(a = 0; a < m; ++a) {
			if(prev[trans[c][a]] == -1) {
				prev[trans[c][a]] = c;
				lett[trans[c][a]] = a;
				q.push(trans[c][a]);
			}
		}
	}
}

char printa[1024];
int printan;
void print(int start) {
	while(start != 0) {
		printa[printan++] = lett[start] + '1';
		start = prev[start];
	}
	int i = printan-1;
	while(i >= 0) {
		for(int j = 0; j < 10 && i >= 0; ++j, --i) {
			putc(printa[i], stdout);
		}
		printf("\n");
	}
}

int main() {
	scanf("%d%d", &n, &m);
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < m; ++j) {
			scanf("%d", &trans[i][j]);
		}
	}
	int termn, cterm;
	scanf("%d", &termn);
	for(int i = 0; i < termn; ++i) {
		scanf("%d", &cterm);
		term[cterm] = 1;
	}
	
	print(bfs());
	
	return 0;
}
