#include <cstdio>
#include <iostream>
#include <vector>

using namespace std;

int k, d, n, size, ans;
vector < int > path;

int sq(int s)
{ return s*s; }

int power(int a, int b)
{
     if (!b) return 1;
     if (b == 1) return a;
     if (b & 1) return a*power(a, b-1);
     if (!(b & 1)) return sq(power(a, b>>1));
}

void find_way(int cur)
{
     while (cur)
     {
         path.push_back(cur);
         cur=(cur-1)/k;
     }
     path.push_back(cur);
}

void solve()
{
      int m;    
      
      find_way(n);
      size=path.size();
      for (int i=size-2; i>=0; --i)
      {
           m=path[i]%k;
           --m;
           if (m == -1)
               m=k-1;
           for (int j=0; j<d; ++j)
               ans+=(m*(power(k, j)));
           ++ans;
           --d;
      }
      printf("%d\n", ans);
}

inline void input()
{ scanf("%d%d%d", &k, &d, &n); }

int main()
{
    input();
    solve();
return 0;
}
