/*
ab.cpp - solution by DP over the sum m + n
We must find the number of (m, n) k-
*/
#include <iostream>
using namespace std;

#define MAXN 256
#define MAXK 512
#define num unsigned long long 
num d[MAXN][MAXN][2*MAXN];

int main(){
  num r = 0;
  int i, j, k, s, mm, nn, kk, m, dkk;
  
  //read
  cin >> mm >> nn >> kk;
  dkk = 2*kk;
  
  //init
  for(i = 0; i <= kk; i++){
    d[0][i][kk - i] = 1;
    d[i][0][kk + i] = 1;
  }
  
  //DP over sum
  for(s = 1; s <= mm + nn; s++){
    for(m = 1; m < s; m++){
      //inner initialization
      d[m][s - m][0] = d[m][s - m - 1][1];
      d[m][s - m][dkk] = d[m - 1][s - m][dkk - 1];
      
      //the DP
      for(k = 1; k < dkk; k++)
        d[m][s - m][k] = d[m - 1][s - m][k - 1] + d[m][s - m - 1][k + 1];            
    }
  }
  
  for(k = 0; k <= dkk; k++){
    r += d[mm][nn][k];      
  }
  cout << r << endl;
  return 0;  
}
