/*Mihail Kovachev - Shumen*/
#include <iostream>
#include <queue>
using namespace std;
#define mp make_pair
struct node
{
  int lev,a,num,id;  
  bool operator ==(node p)
  {
    return  id==p.id;
  }
};
int a[1024][128];
bool used[1024][128];
node prev[1024][128];
bool is_end[1024];


struct cmp
{
    bool operator()(node p1, node p)
    {
        
        if(prev[p1.a][p1.num]==prev[p.a][p.num])
              return p1.num > p.num; 
            
         return p1.id > p.id;
        
    }
};


int n,m;
bool found = 0;
string res;

void update(node pos)
{
 string temp;
 node t=pos;
 while(t.num!=0)
 {
  temp+=t.num+'0';
  t=prev[t.a][t.num];     
 }   

    reverse(temp.begin(), temp.end());
 
    if(!found)res = temp;
        else
    res = min(res, temp);
}
void print()
{
    
    int i;
    for(i=0;i<res.size();i++)
    {
      if(i%50==0&&i!=0)printf("\n");
        printf("%c", res[i]); 
    }
    
}
void BFS()
{
    
    priority_queue<node, vector<node>, cmp> q;
    
    node t;
    t.lev = t.a = t.num = 0;
    q.push(t);
    used[t.a][t.num] = 1;
    t.id = 0;
    int br = 0;
    while(!q.empty())
    {
        node temp = q.top();
        q.pop();
        temp.id = br++;
        
            if(is_end[temp.a]){update(temp);found = true; break;}
            
            int i;
              for(i=1;i<=m;i++)
              {
                    node h;
                    h.lev = temp.lev+1;
                    h.a = a[temp.a][i];
                    h.num = i;
                    
                    if(!used[h.a][h.num])
                    {
                        used[h.a][h.num] = true;
                        prev[h.a][h.num] = temp;
                        q.push(h);
                    }
                }
    }
    
    if(!found) printf("0");
    else
  print();
  
  printf("\n");  
}

int main()
{
    scanf("%d%d", &n, &m);

int i, j;
    
    for (i=0;i<n;i++)
        for (j=1;j<=m;j++)
             scanf("%d", &a[i][j]);

int k;
scanf("%d", &k);
int o;
memset(is_end, 0, sizeof(is_end));
        for (i=0;i<k;i++)
        {
            scanf("%d", &o);
            is_end[o]=true;
        }  
    BFS();
    
    
    
  //  system("pause");
    return 0;
}
