#include <stdio.h>
#include <math.h>
#include <memory.h>
#define MAX 128
#define LONG_NUM_SIZE 64

struct _LONGNUM
{
	char d[LONG_NUM_SIZE];
};
typedef struct _LONGNUM LONGNUM;
#define lnCopy(dest,source) memcpy(dest,source,sizeof(LONGNUM))
void lnFromInt(LONGNUM* ln,int a)
{
	int i=0;
	while(a>0)
	{
		ln->d[i++]=a%10;
		a/=10;
	}
}
void lnIncr(LONGNUM* o,LONGNUM a)
{
	int i;
	char um=0;
	for(i=0;i<LONG_NUM_SIZE;i++)
	{
		o->d[i]+=um+a.d[i];
		if(o->d[i]>9)
		{
			o->d[i]-=10;
			um=1;
		}
		else
			um=0;
	}
}
void lnPrint(LONGNUM ln)
{
	int a=LONG_NUM_SIZE;
	while(ln.d[a]==0)
		a--;
	while(a>-1)
		printf("%c",ln.d[a--]+'0');
}

typedef LONGNUM _type;
#define USLOVIE(a,b) (k>abs(a-b-1)||b>a-1)
int main()
{
	_type t[MAX][MAX];
	int i,j,n,m,k;
	scanf("%d%d%d",&m,&n,&k);
	memset(t,0,sizeof(t));
	for(i=1;i<=k;i++)
	{
		lnFromInt(&t[i][0],i);
		lnCopy(&t[0][i],&t[i][0]);
	}
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
		{
			if(USLOVIE(i,j))
				lnIncr(&t[i][j],t[i-1][j]);
			if(USLOVIE(j,i))
				lnIncr(&t[i][j],t[i][j-1]);
		}
	lnPrint(t[n][m]);
	printf("\n");
	//system("pause");
	return 0;
}
