#include <cstdio>
#include <iostream>
using namespace std;

#define ull unsigned long long

ull f[64];
int k, d, n;

void calcf() {
	f[0] = 1;
	ull p = 1;
	for(int i = 1; i < 64; ++i) {
		f[i] = f[i-1] + (p *= k);
	}
}

void solve() {
	int layer = 0;
	while(f[layer] <= n) layer++;
	ull p = 0;
	while(layer > 0) {
		p += f[d - layer] * ((n-1)%k);
		++p;
		
		n = (n-1)/k;
		--layer;
	}
	cout<<p<<endl;
}

int main() {
	cin>>k>>d>>n;
	
	calcf();
	
	solve();
	
	return 0;
}
