#include <iostream>
#include <cstdio>

using namespace std;

int m, n, k, total, ans;
int mv[256];

inline int mod(const int &a)
{ return (a < 0) ? -a : a; }

bool check(int size)
{
     int one=0, two=0;

     for (int i=0; i<size; ++i)
     {
         if (mv[i] == 1)
            ++one;
         else if (mv[i] == 2)
            ++two;
     }
     if (mod(one-two) > k)
        return false;
     if (two > n)
        return false;
     if (one > m)
        return false;
     return true;
}

void solve(int k)
{
   if (k > total) return;
   if (k)
   {
     if (!(check(k)))
        return;
     else if (k == total)
        ++ans;
   }
   for (int i=1; i<=2; ++i)
   {
       mv[k]=i;
       solve(k+1);
   }
}

inline void input()
{ scanf("%d%d%d", &m, &n, &k); }

int main()
{
    input();
    total=m+n;
    solve(0);
    printf("%d\n", ans);
return 0;
}
