#include <queue>
#include <cstdio>
#include <iostream>

using namespace std;

bool lock[1024], used[1024];
int n, m, locked_num, a, q, ans_size=312312312, size;
int ans[1<<14], path[1<<14], pred[1<<14], path_v[1<<14];
int d[1024][16];

void check(int size)
{
      bool flag=false;
      
      if (ans_size < size) return;
      if (ans_size > size)
         flag=true;
      else if (ans_size == size)
          for (int i=0; i<size; ++i)
              if (path[i] < ans[i])
              {
                  flag=true;
                  break;
              }
              else if (path[i] > ans[i])
              {
                   flag=false;
                   break;
              }
      if (flag == true)
      {
           memcpy(ans, path, sizeof(path));
           ans_size=size;
      }
}

void dfs(int k, int size_p, int size)
{
     if (size_p+1 == size)
        check(size_p);
     for (int i=0; i<m; ++i)
     {
         if (d[k][i] == path_v[size-2-size_p])
         {
             path[size_p]=i+1;
             dfs(d[k][i], size_p+1, size);
         }
     }
}

void bfs(int k)
{
     bool used[1024];
     int lvl=0;
     queue < int > Q;
     
     memset(used, 0, sizeof(used));
     Q.push(k);
     used[k]=1;
     pred[k]=k;
     while(!Q.empty())
     {
          int size=Q.size();
          for (int i=0; i<size; ++i)
          {
              int at=Q.front();
              Q.pop();
              for (int j=0; j<m; ++j)
              {
                  if (!used[d[at][j]])
                  {
                     Q.push(d[at][j]);
                     pred[d[at][j]]=at;
                     used[d[at][j]]=1;
                  }
              }
          }
     }
}

void solve(int k, int size)
{
     bfs(0);
     for (int i=0; i<n; ++i)
     {
         size=0;
         memset(path_v, 0, sizeof(path));
         if (lock[i])
         {
            int temp=i;
            while(temp)
            {
               path_v[size++]=temp;
               temp=pred[temp];
            }
            path_v[size++]=0;
            dfs(0, 0, size);
         }
     }
}

void input()
{
     int temp;
     
     scanf("%d%d", &n, &m);
     for (int i=0; i<n; ++i)
         for (int j=0; j<m; ++j)
             scanf("%d", &d[i][j]);
     scanf("%d", &locked_num);
     for (int i=0; i<locked_num; ++i)
     {
         scanf("%d", &temp);
         lock[temp]=1;
     }
}

int main()
{
    input();
    solve(0, 0);
    for (int i=0; i<ans_size; ++i)
    {
        if ((i+1)%50 == 0)
           printf("\n");
        printf("%d", ans[i]);
    }
    printf("\n");
return 0;
}
