/*
TASK: pass
LANG: C++
ID: Nikolay Hubanov
*/

#include <iostream>
#include <vector>
#include <queue>
#include <cstdio>

using namespace std;

struct edge
{
 int to;
 short but;
 edge() {};
 edge(int _to,short _but) { to=_to; but=_but;}
};

vector<edge> A[1001];
int n,m;
vector<short> p[1001];
queue<int> q;
queue<int> l;
long long int d[1001];
bool used[1001];
bool lock[1001];

void init()
{int u,i,k;
 short j;
 scanf("%d %d",&n,&m);
 for( i=0;i<n;i++)
    for( j=1;j<=m;j++)
        { scanf("%d",&u);
          A[i].push_back(edge(u,j));
        }
 scanf("%d",&k);
 for( i=0;i<k;i++)
     { scanf("%d",&u); lock[u]=1; l.push(u);}
}

void bfs()
{
 int i,k,to,tmp;
 memset(d,63,sizeof(d));
 memset(used,0,sizeof(used));
 used[0]=1;
 d[0]=0;
 q.push(0);
 
 while(!q.empty())
 {
  k=q.front(); q.pop();
  if(lock[k]) continue;
  to=A[k].size();
  for(i=0;i<to;i++)
     {
      tmp=A[k][i].to;
      if(!used[tmp]) {d[tmp]=d[k]+1; p[tmp]=p[k]; p[tmp].push_back(A[k][i].but); used[tmp]=1; q.push(tmp);}
      else if(d[tmp]==d[k]+1) { p[k].push_back(A[k][i].but);
                                if(p[k]<p[tmp]) p[tmp]=p[k];
                                p[k].pop_back();
                                }
      }
  }
  
  q=l;
  while(!l.empty()) l.pop();
  while(!q.empty()) { tmp=q.front(); q.pop();
                      if(d[tmp]) l.push(tmp);
                    }
  
  if(l.empty()) printf("0\n");
  else {
         int best=l.front(); l.pop();
         
         while(!l.empty())
         {
          int k=l.front(); l.pop();
          if(d[k]<d[best]) best=k;
          else if(d[k]==d[best] && p[k]<p[best]) best=k; 
         }
         
         bool endlp=false;
         for(int i=0;i<d[best];i++)
            { printf("%d",p[best][i]); endlp=0;
              if(i%49==0 && i!=0){ printf("\n"); endlp=1;}
            }
         if(!endlp) printf("\n");
       }
}
          
int main()
{
 init();
 bfs();

 return 0;
}
 
